function getTitle(id: any) : any {
    return id;
}

function getTitle2<T>(title: T) : T {
    return title;
}

function getStringParams<T>(arr: Array<T>) : string {
    
    console.log(arr);
    return "some string";
}


let result = getTitle("Hello");
let result2 = getTitle(100);

let result3 = getTitle2<string>("hello").length;
let result4 = getTitle2<number>(10);

console.log(result);
console.log(result2);
console.log(result3);

console.log(getStringParams<string>(['1','2','3','45']));

/*
interface IPage<T> {
    getTitle(): T;
}

class Page<T> implements IPage<T> {
    private title: T;

    constructor(title: T) {
        this.title = title;
    }

    getTitle(): T {
        return this.title
    } 

}

let index = new Page<string>("Home Page");
console.log(index.getTitle());

let index2 = new Page<number>(2);
*/

interface IPage {
    getTitle(): void;
}

class Page implements IPage {
    title: string;

    constructor(title: string) {
        this.title = title;
    }

    getTitle(): void {
        console.log(this.title);
    } 
}

class Index extends Page {
   
    getTitle(): void {
        console.log('index ' + this.title);
    } 
}

class CommonInfo<T extends IPage> {
    getPageInfo(page: T) : void {
        page.getTitle();
    }
}

let index = new Index("index");
let info = new CommonInfo<Page>();
info.getPageInfo(index);

function pageRenderer<T>(param : { new (title : string): T; }, title: string): T {
    return new param(title);
}

let indexpage : Index = pageRenderer(Index, "kuuu");
console.log(indexpage);